/*
 * This Kotlin source file was generated by the Gradle 'init' task.
 */
package io.gitlab.mko_utilities.gradle_plugins.pebble

import io.gitlab.mko_utilities.gradle_plugins.pebble.PluginInfo.PLUGIN_INFO_TASK_NAME
import io.gitlab.mko_utilities.gradle_plugins.pebble.PluginInfo.PLUGIN_NAME
import io.gitlab.mko_utilities.gradle_plugins.pebble.TestConfiguration.FUNCTIONAL_TESTS_RESOURCES
import java.io.File
import kotlin.test.assertTrue
import kotlin.test.assertNotNull
import kotlin.test.Test

/**
 * Functional tests for the 'io.gitlab.mko_utilities.gradle_plugins.pebble' plugin.
 */
class PebblePluginFunctionalTest {

    private fun assertFilesEqual(file1: File, file2: File) {
        require(file1.exists()) { "The following compared file does not exist: ${file1.path}" }
        require(file2.exists()) { "The following compared file does not exist: ${file2.path}" }

        require(file1.length() == file2.length()) { "Files '${file1.path}' and '${file2.path}' have different lengths." }

        val input1 = file1.inputStream()
        val input2 = file2.inputStream()

        var byte1 = input1.read()
        var byte2 = input2.read()

        var byteNb = 1
        while (byte1 != -1 && byte2 != -1) {
            require(byte1 == byte2) { "Files '${file1.path}' and '${file2.path}' have different content at byte $byteNb." }
            byte1 = input1.read()
            byte2 = input2.read()
            byteNb += 1
        }

        require(byte1 == byte2) { "Files '${file1.path}' and '${file2.path}' have different content 'at end' (???)." }

        input1.close()
        input2.close()
    }

    @Test fun `can load HelloWorld test template`() {
        val test =
            TestProject()
                .initWithProjectTemplate(File("${FUNCTIONAL_TESTS_RESOURCES}/helloWorldTest"))
                .run(PLUGIN_INFO_TASK_NAME)

        // Verify the result
        assertTrue(test.output.contains("This is plugin '$PLUGIN_NAME'"))
    }

    @Test fun `can execute task helloWorldTemplatesForMitchell`() {
        val proj =
            TestProject()
                .initWithProjectTemplate(File("${FUNCTIONAL_TESTS_RESOURCES}/helloWorldTest"))
                .finalizeProject()
        proj.run("helloWorldTemplatesForMitchell")

        // Verify the result
        val testProjDir = proj.getRootDirectory()
        val expectedResult = File(testProjDir, "res/pebble/Mitchell/home.html")
        val computedResult = File(testProjDir, "build/pebble/instances/Mitchell/home.html")
        assertFilesEqual(expectedResult, computedResult)
    }

    @Test fun `can execute task helloWorldTemplatesForEddy`() {
        val proj =
            TestProject()
                .initWithProjectTemplate(File("${FUNCTIONAL_TESTS_RESOURCES}/helloWorldTest"))
                .finalizeProject()
        proj.run("helloWorldTemplatesForEddy")

        // Verify the result
        val testProjDir = proj.getRootDirectory()
        val expectedResult = File(testProjDir, "res/pebble/Eddy/home.html")
        val computedResult = File(testProjDir, "build/pebble/instances/Eddy/home.html")
        assertFilesEqual(expectedResult, computedResult)
    }
}
